JD Edwards Anypoint&trade; Studio Connector Demo (Poll Events)
==================================================================

## Introduction

The current demo application provides a simple workflow to get outbound events that it come from Cutomer Master Business Function and save it in a local folder as json file.

## Prerequisites

* Java 7
* Anypoint Studio 5.4.x
* Mule Runtime 3.7.0 EE or higher
* DataWeave
* JDE Connector User manual has been read
* JDE bundle must be created. (See [User Manual Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html): _Generate Bundle_)
* JDE standards ini files (See [User Manual Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html): _Copy JDE ini Files to the Projet_)
* JDE Enterprise Server is reachable from your location
* Application Customer Master information (P03013) with outbound transaction type active.
* Mule Object Store Module Mule Studio Extension installed. Version 1.3.3 * . It allows access and manipulate object stores within Mule.

## Import the project

* Go to **File > Import**
* Select **Anypoint Studio Project from External Location** (under the parent folder "Anypoint Studio")

![Menu](images/jde_connection_config01.png)

* Provide the root path to the demo project folder.
* Select Mule Runtime (3.7.x EE).

![File Selection](images/jde_connection_config02.png)

* Click **Finish**.  
* Set Cookbook credentials inside the file `src/main/app/mule-app.properties`.

```
jde.user=<JDE_USER>
jde.password=<JDE_PASSWORD>
jde.environment=<JDE_ENVIRONMENT>
jde.role=<JDE_ROLE>
jde.imagefoldercache=<LOCAL_FOLDER>
```

* Copy **JDE ini Files** inside the Project.

Put the files inside the project folder in the folder:

* source/main/resource
* root folder of the project

![Test Connection](images/jde_connection_config06.png)


* Inside the Global Elements view, double-click the **JDE Configuration** component.

![Test Connection](images/jde_connection_config03.png)

Add JDE Bundle jar file.

![Test Connection](images/jde_connection_config04.png)

Click "Test Connection".

![Test Connection](images/jde_connection_config05.png)

* A successful message should pop-up.

![Test Connection](images/jde_connection_config07.png)

* Save the project and from the Project Folder, Select **Run as Mule Application**

## About the flows

**1. ProcessJDEEvents:** poll events that it came from transactions generated by Customer Master Business Function.

![Flow HMTL Form](images/jde_connection_flow01.png)

**2. JDE_ProcessTransactions:** it takes transactions from mule queue and it save each customer transaction in local folder. At the end of the workflow it saves the last batch number. This batch number is used by the previous workflow to know what is the last record processed.

![Flow Get](images/jde_connection_flow02.png)

**3. Choice_Exception_Strategy:** global exception strategy that handles every exception that may arise at runtime and forwards it to the HTML form for better troubleshooting in the front-end side.

![Flow 6 Exception](images/jde_connection_flow04.png)

## Configure JD Edwards Application: Customer Master information (P03013)

**1. Processing Options of Customer Master information (P03013)**

 To get customer entered by the application Customer Master information (P03013) is necessary setup the following Processing Options:

![Flow HMTL Form](images/event_jde01.png)

**2. Processing Options of Customer Master Business Function (P0100042)**

Then, the P0100042 version ZJDE0002 needs to have the following value in

![Flow HMTL Form](images/event_jde02.png)

**3. Configure Flat File Cross-Reference (P47002)**

The last configuration that is needed is inform to JDE connector the outbound table used by the MBF to inform the event:

Using "Flat File Cross-Reference (P47002)" form "Work With Flat File Cross-Reference" adds the following record:

* Table: F03012Z1
* Record Type: 1 Header


## Run the demo

* Go to Customer Master information (P03013) with the version correctly Configured

![Flow HMTL Form](images/event_jde10.png)

* Add a Customer.

Click Add

![Flow HMTL Form](images/event_jde11.png)

Enter Customer Master Revision Data

![Flow HMTL Form](images/event_jde12.png)

Enter Customer Name

![Flow HMTL Form](images/event_jde13.png)

Enter Ok to confirm.

![Flow HMTL Form](images/event_jde14.png)


* Go to local folder **output** over project root and see the transaction captured.

![Flow HMTL Form](images/event_jde15.png)

![Flow HMTL Form](images/event_jde16.png)


* **Congratulations!** You have successfully run this demo. Continue exploring the connector by playing with other available [demos](http://modusintegration.github.io/mule-connector-jde/) or visiting the [JD Edwards Connector Documentation Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html) and  the [DevKit Cookbook Tutorial](http://mulesoft.github.io/mule-cookbook-tutorial).
